Title: Logging - OpenStack
Status: In Progress

# Logging - OpenStack

## Introduction

**TODO**

## Scope

**TODO**

## Connecting to rsyslogd

By default, OpenStack is writing its logging output into files and directories for each
component, like `/var/log/nova` or `/var/log/glance`. For the usage of `rsyslogd`, the components
have to be configured to also log to `syslog`. When doing so, configure each component
to log into a different syslog facility. This will help split the logs into individual
components on the central logging server. Employ the following settings:

**/etc/nova/nova.conf:**

````
use_syslog=True
syslog_log_facility=LOG_LOCAL0
````

**/etc/glance/glance-api.conf and /etc/glance/glance-registry.conf:**

````
use_syslog=True
syslog_log_facility=LOG_LOCAL1
````

**/etc/cinder/cinder.conf:**

````
use_syslog=True
syslog_log_facility=LOG_LOCAL2
````

**/etc/keystone/keystone.conf:**

````
use_syslog=True
syslog_log_facility=LOG_LOCAL3
````

The object storage Swift already logs to syslog. So you now can tell the local
rsyslogd clients to pass the logged information to the logging server. You'll do this
by creating a `/etc/rsyslog.d/client.conf` containing the line like:

````
*.* @192.16.1.10
````

where the IP address points to your rsyslogd server. Best approach is to choose a server that's
dedicated to this task only. Here you've got to create the file `/etc/rsyslog.d/server.conf` and
continue the settings.

````
# Enable UDP
$ModLoad imudp
# Listen on 192.168.1.10 only
$UDPServerAddress 192.168.1.10
# Port 514
$UDPServerRun 514
# Create logging templates for nova
$template NovaFile,"/var/log/rsyslog/%HOSTNAME%/nova.log"
$template NovaAll,"/var/log/rsyslog/nova.log"
# Log everything else to syslog.log
$template DynFile,"/var/log/rsyslog/%HOSTNAME%/syslog.log"
*.* ?DynFile
# Log various openstack components to their own individual file
local0.* ?NovaFile
local0.* ?NovaAll
& ~
````

This example contains settings for Nova only. The other OpenStack components
must be added the same way. Using two templates per component, one containing the 
`%HOSTNAME%` variable and one without it, enables a better splitting of the logged 
data. Think about the two example nodes `alpha.example.com` and `bravo.example.com`.
They will write their logging into the files:

- `/var/log/rsyslog/alpha.example.com/nova.log` - only the data of alpha,
- `/var/log/rsyslog/bravo.example.com/nova.log` - only the data of bravo,
- `/var/log/rsyslog/nova.log` - the combined data of both.

This allows a quick overview over all nodes as well as the focused analysis of an
individual node.
