Title: Installing - Ceph
Status: Review

# Installing - Ceph

## Introduction

Typically, OpenStack uses local storage of nodes for the configuration data
as well as for the object storage provided by Swift and the block storage provided by 
Cinder and Glance. But it also can use Ceph as storage backend. Ceph stripes block 
device images across a cluster. This way it provides a better performance than typical 
standalone server. It allows scalabillity and redundancy needs to be satisfied and 
Cinder's RDB driver used to create, export and connect volumes to instances.

## Scope

This document covers the deployment of Ceph via Juju. Other related documents are

- [Scaling Ceph](Scaling-Ceph.md)
- [Troubleshooting Ceph](Troubleshooting-Ceph.md)
- [Appendix Ceph and OpenStack](Appendix-Ceph-and-OpenStack.md)

## Deployment

During the installation of OpenStack we've already seen the deployment of Ceph via

```
juju deploy --config openstack-config.yaml -n 3 ceph
juju deploy --config openstack-config.yaml -n 10 ceph-osd
juju deploy --config openstack-config.yaml ceph-radosgw
```

This will install three Ceph nodes configured with the information contained in the
file `openstack-config.yaml`. This file contains the configuration `block-device: None`
for Cinder, so that this component does not use the local disk. Instead we're calling
Additionally 10 Ceph OSD nodes providing the object storage are deployed and related 
to the Ceph nodes by

```
juju add-relation ceph-osd ceph
```

Once the ceph charm has bootstrapped the cluster, it will notify the ceph-osd charm which 
will scan for the configured storage devices and add them to the pool of available storage.
Now the relation to Cinder and Glance can be established with

```
juju add-relation cinder ceph
juju add-relation glance ceph
```

so that both are using the storage provided by Ceph.

## See also

- https://manage.jujucharms.com/charms/precise/ceph
- https://manage.jujucharms.com/charms/precise/ceph-osd
